<?
/**
 * @package    JTM Reseller
 * @subpackage Component
 * @(#) $Header: /home/cvs/custom_code/com_jtm/admin/controllers/cpanel.php,v 1.19 2010/04/20 06:15:16 cvs Exp $
 * @license    GNU/GPL
 * @copyright (C) 2009-2010 egeshi.com
 * @author Antony Repin <egeshisolutions@gmail.com>
 * @version $Id: cpanel.php,v 1.19 2010/04/20 06:15:16 cvs Exp $
*/

/**
 * TODO
 *  - add userdata table flush at install
 */

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.controller');
require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'helpers'.DS.'helper.php');

/**
 * General administrator controller
 * @package JTM Reseller
 * @subpackage Component
 */
class JtmControllerCpanel extends JController 
{
	var $_model = null;
	var $_view = null;
	var $_com_params = null;
	
	/**
	 * Class constructor
	 *
	 */
	function __construct() {
		
		parent::__construct();
		
		// Defaults
		$default['default_task'] = 'dashboard';
		parent::__construct($default);
		
		// Task map
		$this->registerTask( 'dashboard', 'dashboard' );
		//$this->registerTask( 'download', 'download' );
		$this->registerTask( 'dm', 'download' );
		$this->registerTask( 'cd', 'chooseDownloads' );
		$this->registerTask( 'regreseller', 'regReseller' );
		$this->registerTask( 'addreseller', 'addResellerJX' );
		$this->registerTask( 'loadreseller', 'loadResellerJX' );
		$this->registerTask( 'fl', 'flushTableJX' );
		
		
		$this->_com_params	=& JComponentHelper::getParams( 'com_jtm' );
		$this->_model		=& JController::getModel('Jtm', 'JtmModel');
		
		
	}
	
	/**
	 * method to attach view to controller
	 *
	 * @param string $viewname
	 * @param string $type
	 * @return JtmView object
	 */
	function _attachView($viewname=null, $type=null) {
		
		$view = ucfirst(strtolower($viewname));
		
		if ($type) {
			$type = strtolower($type);
			$view =& $this->getView($view, $type, 'JtmView');
		} else {
			$view =& $this->getView($view, 'html', 'JtmView');
		}
		
		return $view;
	}
	
	/**
	 * Proscesses all download tasks
	 *
	 */
	
	function download() {
		// -----------------------------------------------------------
		// Load common request variables
		// -----------------------------------------------------------
		// -----------------------------------------------------------
		$j		=& JRequest::getInt('j');
		$task	=& JRequest::getString('task');
		$layout	=& JRequest::getString('layout');
		
		$this->_view		=& $this->_attachView('Cpanel');
		$pack_alias_request	=& JRequest::getString('package');
		$this->_model->params = $this->_com_params;
		
		$packages =& JtmHelper::aliases();
		
		if ($this->_model->getResellerConfig()==false) :
		JError::raiseError(500, 'Wrong user data in database. Please reinstall component. We are sorry for inconvenience.');
		else :
		$reseller_config	= $this->_model->getResellerConfig();
		endif;
		
		$start		= 0;
		$step		= 1000;
	    $last		= 35000;
		$urls		= array();
		$templates = array();
		
		JRequest::setVar('tmpl', 'component');
		$this->_view->assignRef('task', $task);
		
		foreach ($packages as $pack) {
			if ($pack['alias']==$pack_alias_request) :
			$pack_title = $pack['title'];
			$pack_alias = $pack['alias'];
			endif;
		}
			
		$u = JtmHelper::getPackageUrl($pack_alias_request, $reseller_config, $start, $last, $step);
			
		$urls = array();
			if ($pack_alias_request == 'tscreenshots'
				|| $pack_alias_request == 'tsources'
				|| $pack_alias_request == 'tkeywords'
				|| $pack_alias_request == 'tcategories'
				|| $pack_alias_request == 'tstyles') {
				for ($i=0;$i<$last;$i+=$step) {
					$to = $i+$step;
					$urls[] = $u.'&from='.$i.'&to='.$to.'&login='.$reseller_config['username'].'&webapipassword='.$reseller_config['apikey'];
				}
			} else {
				$urls[] = $u.'&login='.$reseller_config['username'].'&webapipassword='.$reseller_config['apikey'];
			}
			
			
		foreach ($urls as $url) {
			// Download
			$this->_model->url = $url;
			
			$result = $this->_model->makeDownload();
			
			// Process method result
			if ($result->out_code > 0) {
				$e=$result->errors;
				$this->view->assignRef('errors', $e);
				
				if ($result->message) :
				$msg = JText::_("Errors found");
				$this->_view->assignRef('message', $msg);
				$this->_view->assignRef('error_message', $result->message);
				endif;
				
				$this->_view->display();
			}
			
			
			
			
			$this->_model->_package_alias	= $pack_alias;
			$this->_model->table = $pack_alias;
			
			$this->_model->result = $result->content;
			
			$this->_model->storePackageData();
		}
	
		
		$this->_view->display();
		
		
	}
	
	function chooseDownloads() {
		
		$this->_view	=& $this->_attachView('Cpanel');
		$layout			=& JRequest::getString('layout');
		$task			=& JRequest::getString('task');
		
		$this->_view->setModel($this->_model);
		$this->_view->assignRef('layout', $layout);
		$this->_view->assignRef('task', $task);
		//$this->_view->assignRef('j', $j);
				
		$packages =& JtmHelper::aliases();
				
				
		$this->_model->packages = $packages;
		$this->_view->assignRef('packages', $packages);
				
		$result = $this->_model->getTablesLoaded();
		$this->_view->assignRef('loaded', $result);
				
		$result = $this->_model->getTablesEmpty();
		$this->_view->assignRef('empty', $result);
				
		$this->_view->display();
	}
	
	/**
	 * Default task
	 *
	 */
	function dashboard() {
		
		// Setup
		$this->_view	=& $this->_attachView('Cpanel');
		$this->_view->setModel($this->_model);
		
		// Feed removed in v1.9Beta
		// Load Simplepie and RSS feed
		//jimport('simplepie.simplepie');
		//$feed = new SimplePie();
		//$feed->set_feed_url('http://twitter.com/statuses/user_timeline/43124950.rss');
		//$feed->init();
		//$this->_view->assignRef('feed', $feed);
		
		$this->_view->assign('task', $this->_task);
		
		$this->_view->display();
	}
	
	/**
	 * Flush all records in particular JTM table (AJAX)
	 *
	 */
	
	function flushTableJX() {
		
		JRequest::setVar('tmpl', 'component');
		JRequest::setVar('format', 'raw');
		$this->_view =& $this->_attachView('Cpanel', 'raw');
		
		$task = 'flush';
		
		$table = JRequest::getString('t');
		$this->_model->table = $table;
		$flush = $this->_model->flushTable();
		
		if ($flush && empty($flush->error)) {
			echo $flush->result; // OK
		} else {
			echo $flush->error; // Error
		}
	}

	function loadResellerJX() {
		
		$this->_view =& $this->_attachView('Cpanel');
		
		
		// Load reseller config and process result
		$reseller_config	=& $this->_model->_reseller_config;
		$hasaccount			=& JRequest::getInt('hasaccount', 0);
		$layout				=& JRequest::getString('layout', 'noaccount');
		
		$task = 'regreseller';
		
		if (count($reseller_config)>1) {
			if (!$this->_model->flushResellerConfig()) {
				JError::raiseError(500, 'Errors during save'.'. '.JText::_('Please start over').'.');
				$this->setRedirect('index.php?option=com_jtm&task=regreseller&s=l&'.JUtility::getToken() .'=1');
			}
		} elseif (count($reseller_config)==1) {
				$layout = 'hasaccount';
				$this->_view->assignRef('reseller_config', $reseller_config);
		} else {
			$layout = 'start';
		}
			
		$this->_view->assignRef('task', $task);
		$this->_view->assignRef('hasaccount', $hasaccount);
		$this->_view->assignRef('layout', $layout);
		
		
		$this->_view->display();
		
	}
	
	function regReseller() {
		
		
		
		$this->_view	=& $this->_attachView('Cpanel', null);
		$hasaccount		=& JRequest::getInt('hasaccount', null);
		$task			=& JRequest::getCmd('task', '');
		$s				=& JRequest::getString('s', '');
		$post			=& JRequest::get('post');
		
		// Check and load config
		if ($this->_model->getResellerConfig()==false) :
		JError::raiseError(500, "Error in user data! Please reinstall component or empty user data table.");
		else :
		$reseller_conf =  $this->_model->getResellerConfig();
		endif;
		
		/*
		if ((!empty($reseller_conf['username']) || $hasaccount==1))
		$layout = 'hasaccount';
		else if ($s=="l")
		$layout = 'start';
		else
		$layout = "noaccount";
		*/
		
		switch ($s) {
			
			case "s" :
			
				##############################################################
				## Save reseller
				##############################################################
				
				// Check request for forgery
				JRequest::checkToken() or jexit( 'Invalid Token' );
				
				$app=& JFactory::getApplication();
				if ($_POST['check']!=JUtility::getToken()) {
				   if ($_POST['check']=='post') $app->enqueueMessage('Please check all the fields of the form!<br/>
					If your browser blocks Javascript, then this form will never be successful. This is a security measure.', 'error');
				   return false;
				}
				
				// Process save
				if (!$this->_model->saveReseller($post)) {
					JError::raiseError(500, JText::_('Cannot save reseller configuration'),'!');
				} else {
					$this->setRedirect( 'index.php?option=com_jtm', JText::_('Reseller config saved successfully').'!');
				
				}
				
				$this->_view->display();
		
				break;
			
			case "l":
				
				##############################################################
				## Start user setup
				##############################################################
				$layout = 'hasaccount';
				$this->_view->assignRef('task', $task);
				$this->_view->assignRef('hasaccount', $hasaccount);
				$this->_view->assignRef('layout', $layout);
				$this->_view->assignRef('reseller_conf', $reseller_conf);
				
				$this->_view->display();
				
				break;
				
			default:
		
				$this->setRedirect('http://store.templatemonster.com?aff=egeshi');
			##############################################################
			## Display reseller API data form // Deprecated
			##############################################################
			
			/*
			if ($this->_model->getResellerConfig()) :
			$reseller_conf 	=& $this->_model->getResellerConfig();
			$this->_view->assignRef('reseller_conf', $reseller_conf);
			endif;
			
			// Assign variables to view
			$this->_view->assignRef('task', $task);
			$this->_view->assignRef('layout', $layout);
			*/
			
		}
		
		//$this->_view->display();
	}
	
	
	function updatestatus() {
		JRequest::setVar('tmpl', 'component');
		JRequest::setVar('format', 'raw');
		
		$alias = JRequest::getVar('package', null, 'get');
		$package = &$model->getPackageRecord($alias);
		
		$model->_t_table = $package->table;
		$records =& $model->getRecordsCount();
		if ($records==0) {
			echo '<span style="color: red; font-weight: bold;">'.JText::_("Error while saving data.")."</span>\n";
		} else {
			echo '<h3 style="color: red;">'. JText::_("Downloaded and saved ").$records." records.</h3>\n";
		}
		
	}
	
	function addRresellerJX() {
		
	}
	
	
}