<?php
/**
 * @package    Joomla
 * @subpackage Components
 * administrator/components/com_jtm/libraries/factory.php
 * @license    GNU/GPL
 * @copyright (C) 2009 egeshi.com
 * @author Antony Repin <egeshisolutions@gmail.com>
 * @version $Id: factory.php,v 1.4 2010/04/09 09:15:54 cvs Exp $
*/
defined('_JEXEC') or die('Restricted access');

class JTFactory
{	
	/**
	 * Tries to load a JTM class, located in backend 'libraries' directory
	 *
	 * @param string 	$className 			Dotted class notation, e.g. 'cube.cube' for 'cube/cube.php'
	 * @param bool 		$searchAllBackend 	If set to true, the whole backend is being searched
	 * 
	 * @static 
	 */
	function jtimport( $className, $searchAllBackend = false )
	{
		$parts = explode('.', $className);
		$newClassName = $searchAllBackend ? JPATH_COMPONENT_ADMINISTRATOR.DS : JPATH_COMPONENT_ADMINISTRATOR.DS.'libraries'.DS;
		$newClassName .= implode(DS,$parts); 
		$newClassName .= '.php';

		if(!file_exists($newClassName))
		{
			JError::raiseError(500,'Inexistent Class. Class ' . $className . ' does not exist.' );
		} else {
			require_once($newClassName);
		}
	}
}

function jtimport( $className, $searchAllBackend = false )
{
	return JTFactory::jtimport($className, $searchAllBackend);
}
