<?php
/**
 * General Model for JTM Component
 *
 * @package    JTM Reseller
 * @subpackage Component
 * @(#) $Header: /home/cvs/custom_code/com_jtm/admin/models/jtm.php,v 1.12 2010/04/12 04:07:21 cvs Exp $
 * @license    GNU/GPL
 * @copyright (C) 2009-2010 egeshi.com
 * @author Antony Repin <egeshisolutions@gmail.com>
 * @version $Id: jtm.php,v 1.12 2010/04/12 04:07:21 cvs Exp $
*/

defined('_JEXEC') or die ('Restricted Access');
jimport('joomla.application.component.model');
require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'helpers'.DS.'helper.php');


class JtmModelJtm extends JModel {
	var $_data = null;
	var $_reseller_config = null;
	var $_package = '';
	var $_pack_download_step = null;
	var $_templates_data = null;
	var $_result = null;
	var $_package_alias = '';
	
	function __construct() {
		
		$values = JRequest::getVar('cid', 0, '', 'array');
		
		$this->_reseller_config = $this->getResellerConfig();
		
		$this->_data = new stdClass();
		
		parent::__construct();	
	}
	
	
	/*
	function _setId($id) {
		$this->_id		= $id;
		$this->_data	= null;
	}
	*/
	
	/**
	 * Check whether affiliate exist
	 *
	 * @return int
	 */
	function affiliateExists() {
		$database = &JFactory::getDBO();
		$query = 'SELECT COUNT(*) FROM `#__jtm_udata` LIMIT 1';
		$database->setQuery($query);
		$count = &$database->loadResult();
		return intval($count);
	}
    
        
    function getConnection() {
    	
    	jtimport('http');
		
    	$arguments['Headers']['Pragma']='nocache';
    	$arguments['HostName']='templatemonster.com';
    	
    	set_time_limit(0);
		$http=new http_class;
		$http->host_name=$arguments['HostName'];
		$http->proxy_host_name="";
		$http->proxy_host_port=80;
		$http->socks_host_name = '';
		$http->socks_host_port = 1080;
		$http->socks_version = '5';
		$http->timeout=15;
		$http->data_timeout=20;
		$http->protocol="https";
		
		if ($this->params->get('debug_connection_backend', 1)) :
    	$http->debug=1;
    	else :
    	$http->debug=0;
    	endif;
    	
    	$http->debug_response_body=0;
    	$http->html_debug=0;
    	$http->follow_redirect=1;
    	$http->redirection_limit=5;
    	$http->prefer_curl=1;
    	$url = 'https://www.'.$arguments['HostName'].'/';
    	$error=$http->GetRequestArguments($url,$arguments);
    	
    	
    	
    	//$this->_data = new stdClass();
    	$httpclass = new stdClass();
    	$httpclass->http	=$http;
    	$httpclass->error	=$error;
    	$httpclass->args	=$arguments;
    	
    	$this->_data = $httpclass;
    	
    	return $this->_data;
    }
    
    
    
    function flushResellerConfig() {
    	
    		$db =& JFactory::getDBO();
			$query = 'SELECT `id` FROM `#__jtm_udata`';
			$db->setQuery($query);
			$ids = $db->loadResultArray();
			
			JTable::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR.DS.'tables');
			$table =& JTable::getInstance('udata', 'JTable');
			
			if (!$table->delete($ids)) {
				return false;
			} else {
				return true;
			}
    }
    
    function flushTable() {
    	
    	$this->_data->error ='';
    	
    	$db =& JFactory::getDBO();
    	
    	$table_title = $this->table;
    	
    	//JTable::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR.DS.'tables');
		//$table =& JTable::getInstance($table_title, 'JTable');
		
		$query = "DELETE FROM `#__jtm_$table_title`";
    	$db->setQuery($query);
    		
    	if (!$db->query()) :
    	
    	$this->_data->error = $db->getErrorMsg();
    	endif;
    		
    	$this->_data->result = $db->getAffectedRows();
    	
    	return $this->_data;
    }
    
	function &getPackageRecord() {
		
		if ($this->_alias==null):
		$alias = JRequest::getVar('alias', null);
		else :
		$alias = $this->_alias;
		endif;
		
		$query = "SELECT * FROM #__jtm_packages WHERE "
		.		 "alias='".$alias."'";
		
		$pack_details = $this->_getList($query);
		$pack_details = $pack_details[0];
		
		return $pack_details;
	}
	
	
	function storePackageData() {
		
		$data = $this->result;

		$err = eregi('http-equiv', $data);
		if ($err==true){
			$app = &JFactory::getApplication();
			$msg = eregi_replace('^.*<body>(.*)</body>.*$', '\1', $data);
			$app->redirect('index.php?option=com_jtm', $msg);
			break;
		}
		
		$data = split('\|', $data);
		array_pop($data);
		
		switch ($this->_package_alias) {
			default:
				echo JText::_("Error in parameters! No such alias.");
				break;
				
			case 'tscreenshots':

				$screenshots = array();
				foreach ($data as $key=>$val) {
					$result = split('\[\[\[', $val);
						
					$screenshots[$key]['screenshots']=$result[1];
					$details = split(',', $result[0]);
					array_pop($details);
					$screenshots[$key]['details']=$details;
						
					$screenshots[$key]['id'] = '';
					$screenshots[$key]['tid'] = $screenshots[$key]['details'][0];
					$screenshots[$key]['price'] = $screenshots[$key]['details'][1];
					$screenshots[$key]['exclusive_price'] = $screenshots[$key]['details'][2];
					$screenshots[$key]['addition_date'] = $screenshots[$key]['details'][3];
					$screenshots[$key]['downloads'] = $screenshots[$key]['details'][4];
					$screenshots[$key]['is_hosting'] = $screenshots[$key]['details'][5];
					$screenshots[$key]['is_flash'] = $screenshots[$key]['details'][6];
					$screenshots[$key]['is_adult'] = $screenshots[$key]['details'][7];
					$screenshots[$key]['is_unique_logo'] = $screenshots[$key]['details'][8];
					$screenshots[$key]['is_non_unique_logo'] = $screenshots[$key]['details'][9];
					$screenshots[$key]['is_unique_corporate'] = $screenshots[$key]['details'][10];
					$screenshots[$key]['is_non_unique_corporate'] = $screenshots[$key]['details'][11];
					$screenshots[$key]['author'] = $screenshots[$key]['details'][12];
					$screenshots[$key]['is_full_template'] = $screenshots[$key]['details'][13];
					$screenshots[$key]['pages_amt'] = $screenshots[$key]['details'][14];
					unset($screenshots[$key]['details']);
					unset($data[$key]);
						
					 
					
				}
				$records = $screenshots;
				
				break;
			
			case 'tsources':
				$sources = array();		
				foreach ($data as $key=>$value) {
					$s = split(",", $value);
					$sources[$key] = array();
					$sources[$key]['id']='';
					$sources[$key]['tid']=trim($s[0]);
					$sources[$key]['sources']=ereg_replace('([A-Z])(\.[A-Z])', '\1 \2', trim($s[1]));
				}
				
				$records = $sources;
				break;
				
			case 'tkeywords':
				$keywords = array();
				foreach ($data as $key=>$value) {
					$s = split(",", $value);
					$keywords[$key] = array();
					$keywords[$key]['id']='';
					$keywords[$key]['tid']=trim($s[0]);
					$keywords[$key]['keywords']=$s[1];
				}
				$records = $keywords;
				break;
				
			case 'authors':
				
				$authors = array();
				foreach ($data as $key=>$value) {
					$s = split(",", $value);
					$authors[$key]['id']='';
					$authors[$key]['aid']=trim($s[0]);
					$authors[$key]['nick']=trim($s[1]);
				}
				$records = $authors;
				
				break;
				
			case 'categories':
				$cats = array();
				foreach ($data as $key=>$value) {
					$s = split(",", $value);
					$cats[$key]['id']='';
					$cats[$key]['catid']=trim($s[0]);
					$cats[$key]['title']=trim($s[1]);
					
					if (eregi('&amp;', $cats[$key]['title'])) {
						$cats[$key]['title'] = ereg_replace('&amp;', 'and', $s[1]);
					}
				}
				
				$records = $cats;
				break;
				
			case 'styles':
				$styles = array();
				foreach ($data as $key=>$value) {
					$s = split(",", $value);
					$styles[$key]['id']='';
					$styles[$key]['styleid']=trim($s[0]);
					$styles[$key]['title']=trim($s[1]);

				}
				
				$records = $styles;
				break;
				
			case 'tcategories':
				$cats = array();
				foreach ($data as $key=>$value) {
					$s = split(",", $value);
					$cats[$key]['id']='';
					$cats[$key]['tid']=trim($s[0]);
					$cats[$key]['catid']=trim($s[1]);

				}
				
				$records = $cats;
				break;
				
			case 'tstyles':
				$tstyles = array();
				foreach ($data as $key=>$value) {
					$s = split(",", $value);
					
					$tstyles[$key]['id']='';
					$tstyles[$key]['tid']=trim($s[0]);
					$tstyles[$key]['styleid']=trim($s[1]);

				}
				
				$records = $tstyles;
				break;
				
			case 'featured':
				$featured = array();
				
				$data = $data[0];
				$data = split(",", $data);
				
				foreach ($data as $key=>$value) {
					$featured[$key]['id']='';
					$featured[$key]['tid']=trim($value);
				}
				
				$records = $featured;

				break;
				
			case 'ttypes':
				$types = array();
				
				foreach ($data as $key=>$value) {
					$s = split(",", $value);
					
					$types[$key]['id']='';
					$types[$key]['typeid']=trim($s[0]);
					$types[$key]['description']=trim($s[1]);
				}
				
				$records = $types;
				break;
				
		}
		
		JTable::addIncludePath(JPATH_COMPONENT.DS.'tables'.DS.$this->table.'.php');
		$table =& JTable::getInstance($this->table, 'JTable');
		
		foreach ($records as $single) {
			$ignore = 'id';
			
		    if (!$table->bind($single)) {
		    	$this->setError($this->_db->getErrorMsg());
		    	echo $table->getError();
		    	return false;
		    }
		    		
		    if (!$table->check()) {
		    	$this->setError($this->_db->getErrorMsg());
		    	echo $table->getError();
		    	return false;
		    }
		    		
		    if (!$table->store()) {
		    	$this->setError($this->_db->getErrorMsg());
		    	echo $table->getError();
		    	return false;
		    }
		    		
		}
		return true;
		
	}
	
	
	
	
	
	/**
	 * Load mandatory packages records
	 *
	 * @return object
	 */
	function getPackages() {
		$query = "SELECT * FROM `#__jtm_packages` ORDER BY `id` ASC";
		$packages = $this->_getList($query);
		return $packages;
	}
	
	/**
	 * See what has been already loaded
	 *
	 * @return object
	 */
	function getTablesLoaded() {

		$db = JFactory::getDBO();
		
		$this->tables = array();
		$packages = $this->packages;
		
		foreach ($this->packages as $pack) {
			$table = $pack['alias'];
			$query = "SELECT `id` FROM `jos_jtm_$table`";
			$db->setQuery($query);
			$result = $db->loadResultArray();
			
			if (count($result)>0) :
			array_push($this->tables, $pack['alias']);
			endif;
		}
		
		return $this->tables;
		
	}
	
	/**
	 * See which tables are empty
	 *
	 * @return object
	 */
	function getTablesEmpty() {
		
		$db = JFactory::getDBO();
		
		$packages = $this->packages;
		$this->tables = array();
		
		foreach ($this->packages as $pack) {
			$table = $pack['alias'];
			$query = "SELECT `id` FROM `jos_jtm_$table`";
			$db->setQuery($query);
			$result = $db->loadResultArray();
			
			if (count($result) == 0):
			array_push($this->tables, $pack['alias']);
			endif;
		}
		
		return $this->tables;
		
	}
	
	/**
	 * Enter description here...
	 *
	 * @return mixed
	 * 
	 * output codet for method
	 * 0: ok
	 * 1: debug output
	 * 2: unknown state
	 * 
	 */
	function makeDownload() {
		
		$i=0;
		$results = array();
		$result = array();
		
		$connection = $this->getConnection();
		$http = $connection->http;
		$error = $connection->error;
		$arguments = $connection->args;
		$arguments["RequestURI"]=$this->url;
				
   		$error=$http->Open($arguments);
		if($error=="") {

			
			$error=$http->SendRequest($arguments);
			if($error=="") {
				
					
		
					for(Reset($http->request_headers),$header=0;$header<count($http->request_headers);Next($http->request_headers),$header++)
					{
						$header_name=Key($http->request_headers);
						if(GetType($http->request_headers[$header_name])=="array") {
							for($header_value=0;$header_value<count($http->request_headers[$header_name]);$header_value++) {
								$this->_data->debug = $header_name.": ".$http->request_headers[$header_name][$header_value].'<br />'."\n";
							}
						} else {
							$this->_data->debug = $header_name.": ".$http->request_headers[$header_name].'<br />'."\n";
						}
					}
				
				
				$headers=array();
				$error=$http->ReadReplyHeaders($headers);
				if($error=="") {

						$this->_data->debug = "\n\n".'<br /><br />Response status code:<br />'."\n"
						. $http->response_status.'</div>'."\n";
						
						switch($http->response_status)
						{
							case "301":
								case "302":
									case "303":
										case "307":
											$this->_data->debug = ' (redirect to '.$headers["location"].')<br />'."\n"
											. "Set the \'follow_redirect\' variable to handle redirect responses automatically.<br />\n";
											break;
						}
					
					
					if ($this->params->get('debug_connection_reply', 0)) {
						$this->_data->debug = "".'Response headers:</div>';
						for(Reset($headers),$header=0;$header<count($headers);Next($headers),$header++)
						{
							$header_name=Key($headers);
							if(GetType($headers[$header_name])=="array")
							{
								for($header_value=0;$header_value<count($headers[$header_name]);$header_value++)
								$this->_data->debug = $header_name.": ".$headers[$header_name][$header_value].'<br />';
							} else {
								$this->_data->debug = $header_name.": ".$headers[$header_name].'<br />';
							}
						}
					}
						
					$this->_data->content = array();
					$this->_data->errors = array();
					$this->_data->out_code = 0;
					
					for(;;) {
						$error=$http->ReadReplyBody($body, 2000);
						if (!empty($error) && !empty($body)) {
							
							if ($this->params->get('display_errors_backend', 0)) {
								if(strlen($error)) :
								array_push ($this->_data->errors, $error);
							    $this->_data->message = '<div style="background-color: red; color: white; font-weight: bold; text-align: left;">Error: '.$error.'</div>';
							    $this->_data->out_code = 1;
							    
							    return $this->_data;
							    
								endif;
							}
							
						} elseif (empty($error) && !empty($body)) {
							array_push($this->_data->content, htmlspecialchars($body));
						} elseif (empty($error) && empty($body)) {
							
							$this->_data->content = join(null, $this->_data->content);
							$this->_data->out_code = 0;
							
							return $this->_data;
						} 
						
					}
				}
				
			}
			$http->Close();
		}
	}

	function saveReseller($post) {
    	
    	$db =& JFactory::getDBO();
		
		JTable::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR.DS.'tables');
		$row =& JTable::getInstance('udata');
		
		if (!$row->bind($post)) {
			return JError::raiseWarning( 500, $row->getError() );
		}
		
		if (!$row->check()) {
			return JError::raiseWarning( 500, $row->getError() );
		}
		
		if (!$row->store()) {
			return JError::raiseWarning( 500, $row->getError() );
		}
		
		$row->checkin();
		$this->_data = true;
		

		return $this->_data;
    }
    
    function getRecordsCount() {
		$query = "SELECT * FROM #__jtm_udata";
		$this->_aff_records = $this->_getListCount($query);
		return $this->_aff_records;
	}
	/**
	 * Retrieve reseller user and pass from DB
	 *
	 * @return mixed
	 */
	function getResellerConfig() {
		
		$db =& JFactory::getDBO();
		
		if (empty($this->_resellerConfig )) {
			$query = 'SELECT `id`,`username`,`apikey` FROM `#__jtm_udata`';
			$db->setQuery($query);
			$this->_data = $db->loadAssocList();
		}
		
		
		if (count($this->_data)>1) {
			return false;
		} elseif (count($this->_data)==0){
			return true;
		}
		
		return $this->_data[0];
	}
	
	function checkTableLoaded() {
		
		$db = JFactory::getDBO();
		
		$query = "SELECT COUNT(*) FROM `$this->table`";
		$db->setQuery($query);
		$this->_data = $db->loadResult();
		
		return $this->_data;
	}
	
	
	
}